Subject: allow newlines in single quoted string

This allows a newline to be inside a single quoted string, i.e.

  str = 'hello
word
'
also adds syntax pattern for single quoted string and updates escape chars for
double quoted string.

---

 source/highlightData.c |    4 +++-
 source/parse.y         |    7 +++++--
 2 files changed, 8 insertions(+), 3 deletions(-)

diff --quilt old/source/parse.y new/source/parse.y
--- old/source/parse.y
+++ new/source/parse.y
@@ -1035,8 +1035,11 @@ static int scanString(void)
         handleBackslash = (stopper == '\"');
         len = 0;
         InPtr++;
-        while (*InPtr != '\0' && *InPtr != '\n') {
-            if (*InPtr == stopper) {
+        while (*InPtr) {
+            if (*InPtr == '\n' && handleBackslash) {
+                break;
+            }
+            else if (*InPtr == stopper) {
                 char *endPtr = InPtr++;
                 skipWhitespace();
                 /* is this followed by another string literal? */
diff --quilt old/source/highlightData.c new/source/highlightData.c
--- old/source/highlightData.c
+++ new/source/highlightData.c
@@ -557,8 +557,10 @@ static char *DefaultPatternSets[] = {
         Keyword:\"<(?:break|continue|define|delete|do|else|for|if|in|return|while)>\":::Keyword::\n\
         Braces:\"[{}\\[\\]()<>,.:;~!&|^%*/?=+-]\":::Keyword::\n\
         Global Variable:\"\\$[A-Za-z0-9_]+\":::Identifier1::\n\
+        String sq:\"'\":\"'\"::String::\n\
         String:\"\"\"\":\"\"\"\":\"\\n\":String::\n\
-        String Escape Char:\"\\\\(?:.|\\n)\":::Text Escape:String:\n\
+        String Escape Char:\"\\\\(?:[\\\\\"\"ntbrfave\\n]|[xX][0-9a-fA-F]{1,2}|0*[0-7]{1,3})\":::Text Escape:String:\n\
+        String Escape Char Error:\"\\\\.\":::Flag:String:\n\
         Numeric Const:\"(?<!\\Y)-?[0-9]+>\":::Numeric Const::\n\
         Macro Definition:\"(?<=define)\\s+\\w+\":::Subroutine1::\n\
         Custom Macro:\"\\w+(?=\\s*(?:\\\\\\n)?\\s*[\\(])\":::Subroutine1::\n\
